;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  BootLoader.                                                             ;;
;;  Copyright (C) 2007 Diolan ( http://www.diolan.com )                     ;;
;;                                                                          ;;
;;  This program is free software: you can redistribute it and/or modify    ;;
;;  it under the terms of the GNU General Public License as published by    ;;
;;  the Free Software Foundation, either version 3 of the License, or       ;;
;;  (at your option) any later version.                                     ;;
;;                                                                          ;;
;;  This program is distributed in the hope that it will be useful,         ;;
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of          ;;
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           ;;
;;  GNU General Public License for more details.                            ;;
;;                                                                          ;;
;;  You should have received a copy of the GNU General Public License       ;;
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-----------------------------------------------------------------------------
#define USE_PROD_STRING		1	; 1 - Support for Product string descriptor
;-----------------------------------------------------------------------------

#define DSC_DEV			0x01
#define DSC_CFG			0x02
#define DSC_STR			0x03
#define DSC_INTF		0x04
#define DSC_EP			0x05

#define _DEFAULT		0x01 << 7		; Default Value (Bit 7 is set)
#define _SELF			0x01 << 6		; Self-powered (Supports if set)
#define _RWU			0x01 << 5		; Remote Wakeup (Supports if set)

#define HID_INTF		0x03
#define NO_SUBCLASS		0x00
#define BOOT_INTF_SUBCLASS	0x01

#define HID_PROTOCOL_NONE	0x00
#define HID_PROTOCOL_KEYBOAD	0x01
#define HID_PROTOCOL_MOUSE	0x02

#define _EP01_OUT		0x01
#define _EP01_IN		0x81

#define _CTRL			0x00
#define _ISO			0x01
#define _BULK			0x02
#define _INT			0x03

#define DSC_HID			0x21
#define DSC_RPT			0x22
#define DSC_PHY			0x23

#define HID_NUM_OF_DSC		0x01

#define CFG_ATTRIBUTES		_DEFAULT
;-----------------------------------------------------------------------------
; Descriptor offset of desc_tab[];
;
#define	USB_DEV_DESC_off	0
#define	USB_CFG_DESC_off	3
#define	USB_HID_DESC_off	6
#define	USB_HID_RPT_off		9
#define	USB_LANG_DESC_off	12
#define	USB_MFG_DESC_off	15
#define	USB_PROD_DESC_off	18
;-----------------------------------------------------------------------------
